package{
  import flash.display.Sprite;
  import flash.display.Stage;
  import flash.events.Event;
  import flash.events.KeyboardEvent;
  import flash.events.MouseEvent;
  import flash.text.TextField;
  import flash.text.TextFormat;
  import flash.ui.Keyboard;
  import component.Button;
  import component.ComboBox;

//--------------------------------------------------------------------//
// ANVǗNX
  public class RbfActionManager{

// Xe[W
    internal var stage:Stage;

// ˊ֐ԕ\f
    internal var view:RbfViewModel;

// }EX{^Ă邩ǂ
    internal var pressed:Boolean;

// }EXʒu
    internal var mx:int;
    internal var my:int;

// ؑփR{{bNX
    internal var sel:ComboBox;

// a̓tB[h
    internal var radius:TextField;

//--------------------------------------------------------------------//
// sprite - eXvCg
// view - ˊ֐ԕ\f
// x,y,width - \ʒuAA
// textFormat - eLXg
    public function RbfActionManager(sprite:Sprite,view:RbfViewModel,
      	      	      	      	     x:int,y:int,width:int,
      	      	      	      	     textFormat:TextFormat){
      stage=sprite.stage;
      this.view=view;
      stage.addEventListener(MouseEvent.MOUSE_DOWN,mousePressed);
      stage.addEventListener(MouseEvent.MOUSE_UP,mouseReleased);
      stage.addEventListener(MouseEvent.MOUSE_MOVE,mouseMoved);
      stage.addEventListener(KeyboardEvent.KEY_DOWN,keyPressed);
      pressed=false;
      mx=0;
      my=0;
      addButtons(sprite,x,y,width,textFormat);
    }

//--------------------------------------------------------------------//
// {^ǉ
// sprite - eXvCg
// x,y,width - \ʒuA
// textFormat - eLXg
    internal function addButtons(sprite:Sprite,x:int,y:int,
      	      	      	      	 width:int,textFormat:TextFormat):void{
      var bgColor:uint=0xffffff;
      var fgColor:uint=0x000000;

      var orders:Vector.<String>=
      	Vector.<String>(["Gauss","1","2","3","4","5"]);

      var w:int=width/3;
      sel=new ComboBox(orders,fgColor,bgColor,x,y,
      	      	      	textFormat,ComboBox.ABOVE,0);
      var calcButton:Button=new Button("Calc",fgColor,bgColor,
      	      	      	      	       x+w,y,textFormat);
      var rLabel:TextField=new TextField();
      rLabel.selectable=false;
      rLabel.background=true;
      rLabel.text="Radius:";
      rLabel.x=x+2*w;
      rLabel.y=y;
      radius=new TextField();
      radius.selectable=true;
      radius.background=true;
      radius.text="1.0";
      radius.x=rLabel.x+rLabel.textWidth+5;
      radius.y=y;
      radius.type="input";

      calcButton.addEventListener(MouseEvent.CLICK,calc);

      sprite.addChild(sel);
      sprite.addChild(calcButton);
      sprite.addChild(rLabel);
      sprite.addChild(radius);
    }

//--------------------------------------------------------------------//
// }EX{^̏s
    internal function mousePressed(event:MouseEvent):void{
      pressed=true;
      mx=stage.mouseX;
      my=stage.mouseY;
    }

//--------------------------------------------------------------------//
// }EX{^𗣂̏s
    internal function mouseReleased(event:MouseEvent):void{
      pressed=false;
    }

//--------------------------------------------------------------------//
// }EX{^ړ̏s
    internal function mouseMoved(event:MouseEvent):void{
      if(pressed){
      	if(event.shiftKey){
      	  view.translate(stage.mouseX-mx,stage.mouseY-my);
      	}
      	else if(event.ctrlKey){
      	  view.zoom(stage.mouseX-mx,stage.mouseY-my);
      	}
      	else{
      	  view.rotate(stage.mouseX-mx,stage.mouseY-my);
      	}
      	mx=stage.mouseX;
      	my=stage.mouseY;
      	view.draw();
      }
    }

//--------------------------------------------------------------------//
//L[̏s
    internal function keyPressed(event:KeyboardEvent):void{
      switch(event.keyCode){
      	case Keyboard.NUMPAD_0:
      	case Keyboard.NUMBER_0:
      	case Keyboard.A:
      	case Keyboard.Z:
      	  view.initView();
      	  break;
      	case Keyboard.X:
      	  view.viewX();
      	  break;
      	case Keyboard.Y:
      	  view.viewY();
      	  break;
      }
    }

//--------------------------------------------------------------------//
// Obh_쐬
    internal function calc(event:Event):void{
      var nx:int=20;
      var ny:int=20;
      try{
      	if(sel.index==0){
      	  view.model.createGrid(new GaussRbf(Number(radius.text)),
      	      	      	      	nx,0.0,1.0,ny,0.0,1.0);
      	}
      	else{
      	  view.model.createGrid(new PolyharmonicSpline(sel.index),
      	      	      	      	nx,0.0,1.0,ny,0.0,1.0);
      	}
      	view.setDraw();
      	view.setMessage("");
      }
      catch(e:Error){
      	view.setMessage("Error: "+e.message);
      }
      view.draw();
    }
  }
}
