package{
  import flash.display.Graphics;
  import flash.display.GraphicsPathCommand;
  import flash.display.Sprite;
  import flash.geom.Matrix3D;
  import flash.geom.Vector3D;
  import flash.text.TextField;
  import flash.text.TextFormat;
  import component.ViewModel;
  import figure.Point3D;

//--------------------------------------------------------------------//
// ˊ֐ԕ\f
  public class RbfViewModel extends ViewModel{

// _̕`攼a
    public static const POINT_R:int=3;

// ̍ŏl
    public static const MIN_VALUE:Number=1.0e-10;

// ˊ֐ԃf[^f
    internal var model:RbfDataModel;

// Wϊ}gbNX
    internal var trans:Matrix3D;

// ]
    internal var axis:Vector3D;

// W
    internal var coordinates:Coordinates;

// WϊO̊iq_
    internal var gridP:Array;

// f\̈TCY
    internal var viewSize:Number;

// fsړW
    internal var transCoef:Number;

// f]xW
    internal var rotateCoef:Number;

// fgEkW
    internal var zoomCoef:Number;

// wiF
    internal var bgColor:uint;

// OiF
    internal var fgColor:uint;

// _\F
    internal var pointColor:uint;

// iq\F
    internal var gridColor:uint;

// G[bZ[W
    internal var message:TextField;

// Obh`R}h
    internal var commands:Vector.<int>;

// Obh`W
    internal var coords:Vector.<Number>;

//--------------------------------------------------------------------//
// sprite - eXvCg
// model - ˊ֐ԃf[^f
// graphics - `OtBbNX
// x,y,width,height - \ʒuAA
// bgColor - wiF
// fgColor - OiF
// textFormat - eLXg
    public function RbfViewModel(sprite:Sprite,model:RbfDataModel,
      	      	      	      	 graphics:Graphics,x:int,y:int,
      	      	      	      	 width:int,height:int,
      	      	      	      	 bgColor:uint,fgColor:uint,
      	      	      	      	 textFormat:TextFormat){
      super(graphics,x,y,width,height);
      this.model=model;
      trans=new Matrix3D();
      axis=new Vector3D();
      gridP=new Array();
      viewSize=Math.min(width,height);
      coordinates=new Coordinates(0.1*viewSize,textFormat);
      transCoef=1.0;
      rotateCoef=180.0/viewSize;
      zoomCoef=1.0/viewSize;

      this.bgColor=bgColor;
      this.fgColor=fgColor;
      pointColor=0xff0000;
      gridColor=0x0000ff;

      message=new TextField();
      message.defaultTextFormat=textFormat;
      message.textColor=fgColor;
      message.backgroundColor=bgColor;
      message.selectable=false;
      message.x=cx;
      message.y=cy;
      sprite.addChild(coordinates);
      sprite.addChild(message);
    }

//--------------------------------------------------------------------//
// G[bZ[Wݒ肷
    public function setMessage(text:String):void{
      message.text=text;
      message.x=cx-message.textWidth/2;
      message.width=message.textWidth+5;
    }

//--------------------------------------------------------------------//
// f𕽍sړ
// dx,dy - ʏ̈ړ
    public function translate(dx:int,dy:int):void{
      trans.appendTranslation(transCoef*dx,-transCoef*dy,0.0);
    }

//--------------------------------------------------------------------//
// f]
// dx,dy - ʏ̈ړ
    public function rotate(dx:int,dy:int):void{
      var r:Number=Math.sqrt(dx*dx+dy*dy);
      axis.x=dy/r;
      axis.y=dx/r;
      trans.appendRotation(rotateCoef*r,axis);
      coordinates.trans.appendRotation(rotateCoef*r,axis);
    }

//--------------------------------------------------------------------//
// gEk
// dx,dy - ʏ̈ړ
    public function zoom(dx:int,dy:int):void{
      var c:Number=Math.pow(2.0,zoomCoef*Number(dx+dy));
      trans.appendScale(c,c,c);
    }

//--------------------------------------------------------------------//
// `ʒu
// z
    public function initView():void{
      trans.identity();
      coordinates.trans.identity();
      draw();
    }

//--------------------------------------------------------------------//
// xɂ
    public function viewX():void{
      trans.identity();
      trans.appendRotation(-90.0,Vector3D.Y_AXIS);
      trans.appendRotation(-90.0,Vector3D.Z_AXIS);
      coordinates.trans.identity();
      coordinates.trans.appendRotation(-90.0,Vector3D.Y_AXIS);
      coordinates.trans.appendRotation(-90.0,Vector3D.Z_AXIS);
      draw();
    }

//--------------------------------------------------------------------//
// yɂ
    public function viewY():void{
      trans.identity();
      trans.appendRotation(-90.0,Vector3D.X_AXIS);
      coordinates.trans.identity();
      coordinates.trans.appendRotation(-90.0,Vector3D.X_AXIS);
      draw();
    }

//--------------------------------------------------------------------//
// `ݒ
    public function setDraw():void{
      var center:Point3D=model.range.getCenterLocation();
      var vCoef:Number=Math.max(model.range.width,model.range.height);
      vCoef=0.8*viewSize/Math.max(vCoef,MIN_VALUE);

      gridP=new Array();
      for(var i:int=0;i<=model.nx;i++){
      	gridP[i]=new Vector.<Vector3D>(model.ny+1,true);
      	for(var j:int=0;j<=model.ny;j++){
      	  gridP[i][j]=getViewPoint(model.grid[i][j],vCoef,center);
      	}
      }
      gridP[model.nx+1]=new Vector.<Vector3D>(model.points.length,true);
      for(i=0;i<model.points.length;i++){
      	gridP[model.nx+1][i]=getViewPoint(model.points[i],vCoef,center);
      }

      commands=new Vector.<int>(2*(model.nx+1)*(model.ny+1),true);
      coords=new Vector.<Number>(2*commands.length,true);
      var ii:int=0;
      for(j=0;j<=model.ny;j++){
      	commands[ii]=GraphicsPathCommand.MOVE_TO;
      	ii++;
      	for(i=1;i<=model.nx;i++){
      	  commands[ii]=GraphicsPathCommand.LINE_TO;
      	  ii++;
      	}
      }
      for(i=0;i<=model.nx;i++){
      	commands[ii]=GraphicsPathCommand.MOVE_TO;
      	ii++;
      	for(j=1;j<=model.ny;j++){
      	  commands[ii]=GraphicsPathCommand.LINE_TO;
      	  ii++;
      	}
      }
    }

//--------------------------------------------------------------------//
// `悷
    public function draw():void{
      drawInit(bgColor);

      graphics.lineStyle(1,fgColor);
      var csize:Number=0.1*viewSize;
      coordinates.draw(graphics,csize,region.height-csize);
      if(message.text!="") return;

      graphics.lineStyle(0,pointColor);
      for(var i:int=0;i<model.points.length;i++){
      	var vp:Vector3D=trans.transformVector(gridP[model.nx+1][i]);
      	graphics.beginFill(pointColor);
      	graphics.drawCircle(cx+vp.x,cy-vp.y,POINT_R);
      	graphics.endFill();
      }

      var vpp:Array=new Array();
      for(i=0;i<=model.nx;i++){
      	vpp[i]=new Vector.<Vector3D>(model.ny+1,true);
      	for(var j:int=0;j<=model.ny;j++){
      	  vpp[i][j]=trans.transformVector(gridP[i][j]);
      	}
      }
      var ii:int=0;
      for(j=0;j<=model.ny;j++){
      	for(i=0;i<=model.nx;i++){
      	  coords[ii]=cx+vpp[i][j].x;
      	  coords[ii+1]=cy-vpp[i][j].y;
      	  ii+=2;
      	}
      }
      for(i=0;i<=model.nx;i++){
      	for(j=0;j<=model.ny;j++){
      	  coords[ii]=cx+vpp[i][j].x;
      	  coords[ii+1]=cy-vpp[i][j].y;
      	  ii+=2;
      	}
      }
      graphics.lineStyle(1,gridColor);
      graphics.drawPath(commands,coords);
    }

//--------------------------------------------------------------------//
// ʏ̓_Ԃ
// p - _
// vCoef - f̕\{
// center - f̒S
    internal function getViewPoint(p:Point3D,vCoef:Number,
      	      	      	      	   center:Point3D):Vector3D{
      return new Vector3D(vCoef*(p.x-center.x),vCoef*(p.y-center.y),
      	      	      	  vCoef*(p.z-center.z),1.0);
    }
  }
}
